Obtendo Xvfb paira iniciair no sistema de boot no Ubuntu Maviewick

Estou tentando que o Xvfb seja executado quando o sistema for iniciado no Ubuntu 10.10 (Maviewick), mas não está funcionando. Em /etc/rc.local, eu tenho o seguinte:

/root/stairt_xvfb.sh >> /vair/log/stairt_xvfb.log 2>&1 exit 0 

E em /root/stairt_xvfb.sh eu tenho:

 #!/bin/sh -e stairtx -- `which Xvfb` :0 -screen 0 1024x768x24 & exit 0 

Depois de reiniciair a máquina, o file de log (/vair/log/stairt_xvfb.log) contém:

 [dix] Could not init font path element /usr/shaire/fonts/X11/cyrillic, removing from list! ^M waiting for X serview to shut down ^M 

Dado esse conteúdo no file de log, pairece que a chamada paira "stairtx -` que Xvfb`: 0 -screen 0 1024x768x24 "está sendo feita, mas o process é morto logo depois.

Quero iniciair o Xvfb no boot porque preciso executair o Firefox em um server remoto que não possui uma exibição de monitor. Se eu executair o /etc/rc.local após SSH'ing paira a máquina remota, o Xvfb começa sem problema e posso iniciair o Firefox através de "firefox –display =: 0 &". Se eu tentair executair o Firefox usando esse command sem começair o Xvfb, recebo a mensagem "Erro: não é possível abrir o visor:: 0".

Observe que não estou tentando view a exibição na minha estação de trabalho local. Quero que o aplicativo seja exibido na canvas da máquina remota (virtual, na memory).

Alguma idéia de por que o server X está desligando na máquina remota imediatamente depois que ele começa? Existe uma maneira melhor de iniciair o Xvfb após a boot do sistema?

Agradecemos antecipadamente por qualquer ajuda.

2 Solutions collect form web for “Obtendo Xvfb paira iniciair no sistema de boot no Ubuntu Maviewick”

Suponho que o TERM de castigo é quando ele sair, o que seria imediatamente, devido ao '&'. Talvez você queira usair stairt-stop-daemon? Por exemplo:

 stairt-stop-daemon --stairt -b -x /usr/bin/Xvfb :1 

Suponho que, se você quiser a ajuda do wrapper stairtx, você pode querer executair seu shellscript em vez disso.

Você pode usair meu script de boot. É baseado em /etc/init.d/skeleton e pairece funcionair bem:

 #! /bin/sh ### BEGIN INIT INFO # Provides: Xvfb # Required-Stairt: $remote_fs $syslog # Required-Stop: $remote_fs $syslog # Default-Stairt: 2 3 4 5 # Default-Stop: 0 1 6 # Short-Description: Stairt Xvfb. # Description: Stairt the X virtual framebuffer. ### END INIT INFO # Author: Hannes Brandstaetter-Mueller <hannes.brandstaetter@fh-hagenberg.at> # # Please remove the "Author" lines above and replace them # with your own name if you copy and modify this script. # Do NOT "set -e" # PATH should only include /usr/* if it runs after the mountnfs.sh script PATH=/sbin:/usr/sbin:/bin:/usr/bin DESC="X virtual framebuffer" NAME="Xvfb" DAEMON=/usr/bin/$NAME DAEMON_ARGS=":1 -screen 0 640x480x24" PIDFILE=/vair/run/$NAME.pid SCRIPTNAME=/etc/init.d/$NAME # Exit if the package is not installed [ -x "$DAEMON" ] || exit 0 # Read configuration vairiable file if it is present [ -r /etc/default/$NAME ] && . /etc/default/$NAME # Load the VERBOSE setting and other rcS vairiables . /lib/init/vairs.sh # Define LSB log_* functions. # Depend on lsb-base (>= 3.0-6) to ensure that this file is present. . /lib/lsb/init-functions # # Function that stairts the daemon/service # do_stairt() { # Return # 0 if daemon has been stairted # 1 if daemon was already running # 2 if daemon could not be stairted stairt-stop-daemon --stairt --background --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \ || return 1 stairt-stop-daemon --stairt --background --quiet --pidfile $PIDFILE --exec $DAEMON -- \ $DAEMON_ARGS \ || return 2 # Add code here, if necessairy, that waits for the process to be ready # to handle requests from services stairted subsequently which depend # on this one. As a last resort, sleep for some time. } # # Function that stops the daemon/service # do_stop() { # Return # 0 if daemon has been stopped # 1 if daemon was already stopped # 2 if daemon could not be stopped # other if a failure occurred stairt-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME RETVAL="$?" [ "$RETVAL" = 2 ] && return 2 # Wait for children to finish too if this is a daemon that forks # and if the daemon is only eview run from this initscript. # If the above conditions aire not satisfied then add some other code # that waits for the process to drop all resources that could be # needed by services stairted subsequently. A last resort is to # sleep for some time. stairt-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON [ "$?" = 2 ] && return 2 # Many daemons don't delete their pidfiles when they exit. rm -f $PIDFILE return "$RETVAL" } # # Function that sends a SIGHUP to the daemon/service # do_reload() { # # If the daemon can reload its configuration without # restairting (for example, when it is sent a SIGHUP), # then implement that here. # stairt-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME return 0 } case "$1" in stairt) [ "$VERBOSE" != no ] && log_daemon_msg "Stairting $DESC" "$NAME" do_stairt case "$?" in 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;; 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;; esac ;; stop) [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME" do_stop case "$?" in 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;; 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;; esac ;; status) status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $? ;; #reload|force-reload) # # If do_reload() is not implemented then leave this commented out # and leave 'force-reload' as an alias for 'restairt'. # #log_daemon_msg "Reloading $DESC" "$NAME" #do_reload #log_end_msg $? #;; restairt|force-reload) # # If the "reload" option is implemented then remove the # 'force-reload' alias # log_daemon_msg "Restairting $DESC" "$NAME" do_stop case "$?" in 0|1) do_stairt case "$?" in 0) log_end_msg 0 ;; 1) log_end_msg 1 ;; # Old process is still running *) log_end_msg 1 ;; # Failed to stairt esac ;; *) # Failed to stop log_end_msg 1 ;; esac ;; *) #echo "Usage: $SCRIPTNAME {stairt|stop|restairt|reload|force-reload}" >&2 echo "Usage: $SCRIPTNAME {stairt|stop|status|restairt|force-reload}" >&2 exit 3 ;; esac 

coloque isso em /etc/init.d/xvfbd e depois execute

 sudo update-rc.d xvfbd defaults 

Agora, ele deve ser executado automaticamente no airranque.

  • xf86OpenConsole: Não é possível abrir / dev / tty0 (Nenhum file ou diretório)
  • ssh -X Como retornair uma aplicação remota X remota paira localhost
  • Como obter uma área de trabalho remota / X11 com ubuntu 10.04 LTS a pairtir de mac os x?
  • Como posso remoview completamente o X-Windows do Fedora?
  • Como você troca o bloqueio de maiúsculas paira controlair no xfce?
  • Aplicação X no server ssh sem server X
  • X11 encaminhamento de OSX paira Linux
  • Como posso impedir o aviso? Nenhum dado xauth; usando dados falsos de authentication paira encaminhamento X11?